;QMesh v1.0 Preacher
;-----------------------------------------------------------
;fix texture stuff. then release...v1.0

;----
Structure xyz
 x.f
 y.f
 z.f
EndStructure
Structure vertexstruct
 x.f
 y.f
 z.f
 tx.f
 ty.f
EndStructure
Structure facestruct
 v1.w
 v2.w
 v3.w
EndStructure

ProcedureDLL QMesh_Init()
 NewList faces.facestruct()
 NewList vertex.vertexstruct()
EndProcedure
ProcedureDLL QMesh_End()
EndProcedure

ProcedureDLL QObject(mesh) ; Creates a mesh from the internal list
  vertexspace=(CountList(vertex())*5)*4
  facespace=(CountList(faces())*3)*2
  mem=AllocateMemory((vertexspace+facespace))
  mempos=mem
  memvertex=mempos
  ResetList(vertex())
  While NextElement(vertex())
    PokeF(mempos,vertex()\x):mempos+4
    PokeF(mempos,vertex()\y):mempos+4
    PokeF(mempos,vertex()\z):mempos+4
  Wend
  memface=mempos
  ResetList(faces())
  While NextElement(faces())
    PokeW(mempos,faces()\v1):mempos+2
    PokeW(mempos,faces()\v2):mempos+2
    PokeW(mempos,faces()\v3):mempos+2
  Wend
  memtexture=mempos
  ResetList(vertex())
  While NextElement(vertex())
    PokeF(mempos,vertex()\tx):mempos+4
    PokeF(mempos,vertex()\ty):mempos+4
  Wend
  CreateMesh(mesh)
  SetMeshData(mesh,#PB_Mesh_Vertices     ,mem       ,CountList(vertex()))
  SetMeshData(mesh,#PB_Mesh_Triangles    ,memface   ,CountList(faces()))
  SetMeshData(mesh,#PB_Mesh_UVCoordinates,memtexture,CountList(vertex()))
  FreeMemory(mem)
  ClearList(vertex())
  ClearList(faces())
EndProcedure
ProcedureDLL QVertex(x.f,y.f,z.f,texturex.f,texturey.f); Adds a vertex to internal list
  AddElement(vertex())
  vertex()\x=x
  vertex()\y=y
  vertex()\z=z
  vertex()\tx=texturex
  vertex()\ty=texturey
EndProcedure
ProcedureDLL QFace(v1.w,v2.w,v3.w); Adds a triangle from three vertices
  AddElement(faces())
  faces()\v1=v1
  faces()\v2=v2
  faces()\v3=v3
EndProcedure
ProcedureDLL QFace2(v1.w,v2.w,v3.w,v4.w); Adds two triangles forming a square from four vertices
  AddElement(faces())
  faces()\v1=v1
  faces()\v2=v2
  faces()\v3=v3
  AddElement(faces())
  faces()\v1=v3
  faces()\v2=v4
  faces()\v3=v1
EndProcedure
ProcedureDLL QSphere(n.w)
   TWOPI.f  = 6.28318530
   PIDIV2.f = 1.57079632
   e.xyz
   radius=1:ver=1
   If n<0:n=-n:EndIf   
   For j=0 To n/2 
      theta1.f=((j*TWOPI)/n)-PIDIV2
      theta2.f=(((j+1)*TWOPI)/n)-PIDIV2
      For i=0 To n 
         theta3.f =(i*TWOPI)/n
         e\x = Cos(theta2) * Cos(theta3)
         e\y = Sin(theta2)
         e\z = Cos(theta2) * Sin(theta3)
         QVertex(e\x,e\y,e\z,i/n,2*(j+1)/n)
         e\x = Cos(theta1) * Cos(theta3)
         e\y = Sin(theta1)
         e\z = Cos(theta1) * Sin(theta3)
         QVertex(e\x,e\y,e\z,i/n,2*j/n)
      Next
    Next
    For y=0 To n
    For x=0 To n
         i=x+(y*n)
         QFace(i,i+1,i+2)
         QFace(i+1,i,i+2)
    Next 
    Next
EndProcedure
ProcedureDLL QDisk(n.w)
   TWOPI.f  = 6.28318530
   e.xyz
   t.f=TWOPI/n
   QVertex(0,0,0,0.5,0.5)
    For i=0 To n  
      e\x = Cos(i*t)   
      e\z = Sin(i*t)   
      QVertex(e\x,0,e\z,e\x,e\z)
    Next 
    For i=1 To n
     QFace(0,i,i+1)
     QFace(0,i+1,i)
    Next
EndProcedure
ProcedureDLL QCone(n.w)
   TWOPI.f  = 6.28318530
   e.xyz
   QVertex(0,0,0,0.5,0.5)
   QVertex(0,1,0,0.5,0.5)
   t.f=TWOPI/n
    For i=0 To n  
      e\x = Cos(i*t)   
      e\z = Sin(i*t)   
      QVertex(e\x,0,e\z,e\x,e\z)
    Next 
    For i=2 To n+1
     QFace(0,i,i+1)
     QFace(0,i+1,i)
     QFace(1,i,i+1)
     QFace(1,i+1,i)
    Next
EndProcedure
ProcedureDLL QCylinder(n.w)
   TWOPI.f  = 6.28318530
   e.xyz
   t.f=TWOPI/n
   QVertex(0,0,0,0.5,0.5)
   QVertex(0,1,0,0.5,0.5)
    For i=0 To n  
      e\x = Cos(i*t)   
      e\z = Sin(i*t)   
      QVertex(e\x,0,e\z,(1/n)*i,0)
      QVertex(e\x,1,e\z,(1/n)*i,1)
    Next 
    For i=1 To (n*2)+1
     QFace(0,i,i+2)
     QFace(1,i+2,i)
     QFace(i,i+1,i+2)
     QFace(i,i+2,i+1)
    Next
EndProcedure
ProcedureDLL QCube()
    QVertex(0, 0, 0, 0     ,0) ;0Cube data
    QVertex(1, 0, 0, 0.166 ,0) ;1
    QVertex(1, 0, 1, 0.332 ,0) ;2
    QVertex(0, 0, 1, 0.498 ,0) ;3
    QVertex(0, 1, 0, 0     ,1) ;4
    QVertex(1, 1, 0, 0.166 ,1) ;5
    QVertex(1, 1, 1, 0.332 ,1) ;6
    QVertex(0, 1, 1, 0.498 ,1) ;7
    QVertex(0, 0, 0, 0.664 ,0) ;8
    QVertex(0, 1, 0, 0.664 ,1) ;9
    QVertex(0, 0, 0, 0.664 ,0) ;10
    QVertex(1, 0, 0, 0.83  ,0) ;11
    QVertex(1, 0, 1, 0.83  ,1) ;12
    QVertex(0, 0, 1, 0.664 ,1) ;13
    QVertex(0, 1, 0, 0.83  ,0) ;14
    QVertex(1, 1, 0, 1     ,0) ;15
    QVertex(1, 1, 1, 1     ,1) ;16
    QVertex(0, 1, 1, 0.83  ,1) ;17
    QFace2(4,5,1,0)     ;1  
    QFace2(5,6,2,1)     ;2
    QFace2(6,7,3,2)     ;3
    QFace2(7,9,8,3)     ;4
    QFace2(10,11,12,13) ;5
    QFace2(17,16,15,14) ;6
EndProcedure


; ExecutableFormat=
; CursorPosition=31
; FirstLine=1
; EOF
