;Example for the QMesh Lib.

IncludeFile "qmesh2.pb"

QMesh_Init()

image.s="qmesh_texture.jpg"; remember sizes 64*64 128*128 etc.

earth.s="earth.jpg"
cube.s="cube.jpg"
#CameraSpeed = 1

DefType.f KeyX, KeyY, MouseX, MouseY


If InitEngine3D()
  InitSprite()
  InitKeyboard()
  InitMouse()
  
  If OpenWindow(0,0,0,300,300,#PB_Window_SystemMenu,"Example")
     OpenWindowedScreen(WindowID(), 0, 0, 300,300, 0, 0, 0)

    ;set up the cube data 
    QVertex(-1, -1, -1, 0   , 0.33) ;Cube data
    QVertex( 1, -1, -1, 0.33, 0.33) 
    QVertex( 1, -1,  1, 0.33, 0   ) 
    QVertex(-1, -1,  1, 0   , 0   ) 
    QVertex(-1,  1, -1, 0.66, 1   ) 
    QVertex( 1,  1, -1, 1   , 1   ) 
    QVertex( 1,  1,  1, 1   , 0.66) 
    QVertex(-1,  1,  1, 0.66, 0.66) 
    Triamgle=#False;#True
    If Triangle
     QFace(0,1,2) ;1
     QFace(2,3,0) ;
     QFace(6,5,4) ;2
     QFace(4,7,6) ;
     QFace(1,5,6) ;3
     QFace(6,2,1) ;
     QFace(7,4,0) ;4
     QFace(0,3,7) ;
     QFace(5,1,0) ;5
     QFace(0,4,5) ;
     QFace(2,6,7) ;6
     QFace(7,3,2) ;
    Else
     QFace2(0,1,2,3) ;1  
     QFace2(6,5,4,7) ;2
     QFace2(1,5,6,2) ;3
     QFace2(7,4,0,3) ;4
     QFace2(5,1,0,4) ;5
     QFace2(2,6,7,3) ;6
    EndIf
    QObject(0); Put our object in mesh 0
   
    CreateEntity(0, MeshID(0), CreateMaterial(0, LoadTexture(0,image)))
    QSphere(20)
    QObject(1)
    QDisk(20)
    QObject(2)
    QCone(20)
    QObject(3)
    QCylinder(20)
    QObject(4)
    QCube()
    QObject(5)


    CreateEntity(1, MeshID(1), CreateMaterial(1, LoadTexture(1,earth)))
    CreateEntity(2, MeshID(2), CreateMaterial(2, LoadTexture(2,image)))
    CreateEntity(3, MeshID(3), CreateMaterial(3, LoadTexture(3,image)))
    CreateEntity(4, MeshID(4), CreateMaterial(4, LoadTexture(4,image)))
    CreateEntity(5, MeshID(5), CreateMaterial(5, LoadTexture(5,cube)))
    EntityLocate(0,0,4,4) 
    EntityLocate(1,3,4,4) 
    EntityLocate(2,6,4,4) 
    EntityLocate(3,9,4,4) 
    EntityLocate(4,12,4,4) 
    EntityLocate(5,15,4,4) 


    CreateCamera(0, 0, 0, 100, 100)
    CameraLocate(0,4,4,20)
    
    Repeat
      ClearScreen(0, 0, 0)
      If ExamineKeyboard()
        If KeyboardPushed(#PB_Key_Left)
          KeyX = -#CameraSpeed 
        ElseIf KeyboardPushed(#PB_Key_Right)
          KeyX = #CameraSpeed 
        Else
          KeyX = 0
        EndIf
                  
        If KeyboardPushed(#PB_Key_Up)
          KeyY = -#CameraSpeed 
        ElseIf KeyboardPushed(#PB_Key_Down)
          KeyY = #CameraSpeed 
        Else
          KeyY = 0
        EndIf

      EndIf
      If ExamineMouse()
        MouseX = -(MouseDeltaX()/10)*#CameraSpeed/2
        MouseY = -(MouseDeltaY()/10)*#CameraSpeed/2
      EndIf
      RotateEntity(0, 0.4, 0.3, 0.1)
      RotateEntity(1, 0.4, 0.3, 0.1)
      RotateEntity(2, 0.4, 0.3, 0.1)
      RotateEntity(3, 0.4, 0.3, 0.1)
      RotateEntity(4, 0.4, 0.3, 0.1)
      RotateEntity(5, 0.4, 0.4, 0.4)
      RotateCamera(0, MouseX, MouseY, RollZ)
      MoveCamera  (0, KeyX, 0, KeyY)
      RenderWorld()
      FlipBuffers()
      Delay(3)
    Until KeyboardPushed(#PB_Key_Escape) Or Quit = 1
  EndIf
EndIf

; ExecutableFormat=Windows
; CursorPosition=61
; FirstLine=57
; EnableXP
; Executable=C:\SOURCES\Libraries\QMesh\QMesh_Example.exe
; DisableDebugger
; EOF